#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

main(int argc, char *argv[])
{
	int source_fd, dest_fd;
	int count;
	char buffer[1024];
	
	if (argc != 3){
		fprintf(stderr, "Usage %s <source> <dest>\n", argv[0]);
		exit(1);
	}
	if ((source_fd = _my_open(argv[1], O_RDONLY)) == -1) {
		fprintf(stderr, "Cannot open file %s\n", argv[1]);
		exit(1);
	}
        if ((dest_fd = _my_open(argv[2], O_RDONLY)) > 0) {
		fprintf(stderr, "File %s already exists\n", argv[2]);
		exit(1);
	}
	if ((dest_fd = _my_open(argv[2], O_CREAT|O_RDWR, S_IREAD|S_IWRITE)) == -1) {
		 fprintf(stderr, "Cannot create file %s\n", argv[2]);
		 exit (1);
	}
	while ((count = _my_read(source_fd, buffer, sizeof(buffer))) > 0) {
		fprintf(stderr, "Read %d bytes from fd %d\n", count, source_fd);
		if (_my_write(dest_fd, buffer, count) != count)
			fprintf(stderr, "Could not write to file %s\n", argv[2]);
		else
			fprintf(stderr, "Wrote %d bytes to fd %d\n", count, dest_fd);
	}	
	_my_close(source_fd);
	_my_close(dest_fd);
}
